<?php
/**
 * The control file of oidc module of ZenTaoPMS.
 *
 * @copyright   Copyright 2009-2020 禅道软件（青岛）有限公司(ZenTao Software (Qingdao) Co., Ltd. www.cnezsoft.com)
 * @license     ZPL(http://zpl.pub/page/zplv12.html) or AGPL(https://www.gnu.org/licenses/agpl-3.0.en.html)
 * @package     oidc
 * @link        http://www.zentao.net
 */
class oidc extends control
{
    public function index($code = '')
    {
        $this->app->loadConfig('oidc');
        if(empty($this->config->oidc->status))
        {
            $link = helper::createLink('user', 'login');
            $link = str_replace('oidc.php', 'index.php', $link);
            return print(js::locate($link, 'parent'));
        }

        /* Get oidc code. */
        if(empty($code)) $this->oidc->getOidcCode();

        /* Get token by code. */
        $tokenResponse = $this->oidc->getToken($code);
        if(!isset($tokenResponse['access_token'])) die('error response: ' . json_encode($tokenResponse));

        /* Get user account. */
        $userInfo = $this->oidc->getUserInfo($tokenResponse['access_token']);
        if(!isset($userInfo['preferred_username'])) die('error userInfo:' . $userInfo);

        /* Check user exist. */
        $this->oidc->checkUserExist($userInfo);
    }

    /**
     * Set the interface configuration.
     *
     * @access public
     * @return void
     */
    public function browse()
    {
        if($_POST)
        {
            $settings = fixer::input('post')->get();

            $this->loadModel('setting');
            $this->setting->deleteItems('owner=system&module=oidc');
            $this->setting->setItems('system.oidc', $settings);

            if(dao::isError()) return $this->send(array('result' => 'fail', 'message' => dao::getError()));
            return $this->send(array('result' => 'success', 'message' => $this->lang->saveSuccess, 'locate' => 'reload'));
        }

        $this->view->title   = $this->lang->oidc->common;
        $this->view->oidc = empty($this->app->config->oidc) ? '' : $this->app->config->oidc;
        $this->display();
    }
}
